//  Created by Sir Cheshire

#import "AppDelegate.h"
#import "InitialView.h"

@implementation AppDelegate

@synthesize window = _window;
@synthesize rootView = _rootView;

- (void)addMessageFromRemoteNotification:(NSDictionary*)userInfo updateUI:(BOOL)updateUI
{
    NSString* alertValue = [[userInfo valueForKey:@"aps"] valueForKey:@"alert"];
    
    NSLog(@"%@",alertValue);
    
    _rootView.mensagem = alertValue;
    
	
        /*if (active) 
        {
            UIAlertView* alerta = [[UIAlertView alloc] initWithTitle:@"Push recebido" message:alertValue delegate:nil cancelButtonTitle:@"Ok" otherButtonTitles:nil];
            
            [alerta show];
        }*/
        [self.window.rootViewController dismissModalViewControllerAnimated:NO];
        [_rootView showMsg];
    
}

- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions
{
    _rootView = [[InitialView alloc] init];
    
    [[UIApplication sharedApplication] registerForRemoteNotificationTypes:
     (UIRemoteNotificationTypeNewsstandContentAvailability | 
      UIRemoteNotificationTypeBadge | 
      UIRemoteNotificationTypeSound  |
      UIRemoteNotificationTypeAlert 
      )];
    
    
    [self.window setRootViewController:_rootView];
    
    
    [self.window makeKeyAndVisible];
    //inicio da parte colada de notification
    
    
    NSDictionary *remoteNotif = [launchOptions objectForKey: UIApplicationLaunchOptionsRemoteNotificationKey];
    
    if (remoteNotif) 
    {      
        [self addMessageFromRemoteNotification:remoteNotif updateUI:NO];
    }

    [UIApplication sharedApplication].applicationIconBadgeNumber = 0;

    return YES;
}

- (void)application:(UIApplication *)app didRegisterForRemoteNotificationsWithDeviceToken:(NSData *)deviceToken { 
    
    NSString *str = [NSString stringWithFormat:@"Device Token=%@",deviceToken];
    NSLog(@"%@",str);
    
}

- (void)application:(UIApplication *)app didFailToRegisterForRemoteNotificationsWithError:(NSError *)err { 
    
    NSString *str = [NSString stringWithFormat: @"Error: %@", err];
    NSLog(@"%@",str);    
    
}

- (void)application:(UIApplication*)application didReceiveRemoteNotification:(NSDictionary*)userInfo
{
	[self addMessageFromRemoteNotification:userInfo updateUI:YES];
}
//fim da parte colada de notification

- (void)applicationWillResignActive:(UIApplication *)application
{
    /*
     Sent when the application is about to move from active to inactive state. This can occur for certain types of temporary interruptions (such as an incoming phone call or SMS message) or when the user quits the application and it begins the transition to the background state.
     Use this method to pause ongoing tasks, disable timers, and throttle down OpenGL ES frame rates. Games should use this method to pause the game.
     */
}

- (void)applicationDidEnterBackground:(UIApplication *)application
{
    active = NO;
}

- (void)applicationWillEnterForeground:(UIApplication *)application
{
    /*
     Called as part of the transition from the background to the inactive state; here you can undo many of the changes made on entering the background.
     */
}

- (void)applicationDidBecomeActive:(UIApplication *)application
{
    [UIApplication sharedApplication].applicationIconBadgeNumber = 0;
    
    active = YES;
}

- (void)applicationWillTerminate:(UIApplication *)application
{
    /*
     Called when the application is about to terminate.
     Save data if appropriate.
     See also applicationDidEnterBackground:.
     */
}

@end
