//  Created by Sir Cheshire

#import "FotosGaleria.h"
#import "LogicCore.h"
#import "Foto.h"
#import "FotoZoom.h"

@implementation FotosGaleria
@synthesize loading;

@synthesize url,scroll;

- (void)download:(ImgDownload *)download didFailWithError:(NSError *)error
{
    NSLog(@"erro no download da imagem de indice %d de endereço %@",[downloaders indexOfObject:download],download.urlString);
    
    dCount++;
    if (dCount == [downloaders count]) 
    {
        [loading stopAnimating];
        downloaders = nil;
    }
}

-(void) finishButton:(ImgDownload*) downloader
{
    UIImage* image = downloader.image;
    
    UIImageView* imagem = [[UIImageView alloc] initWithFrame:CGRectMake(3, 3, 157, 114)];
    
    [imagem setImage:image];
    
    UIButton* button = [botoes objectAtIndex:[downloaders indexOfObject:downloader]];
    
    [button addSubview:imagem];
}

- (void)downloadDidFinishDownloading:(ImgDownload *)download
{
    
    [self finishButton:download];
    
    download.delegate = nil;
    NSLog(@"terminou download na imagem de indice %d de endereço %@",[downloaders indexOfObject:download], download.urlString);
    
    [lock lock];
    
    dCount++;
    if (dCount == [downloaders count]) 
    {
        [loading stopAnimating];
        downloaders = nil;
    }
    [lock unlock];
}

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)didReceiveMemoryWarning
{
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}

-(void) startDownloaders
{
    if (ready) 
    {
        for (Foto * f in fotos) 
        {
            //foto
            ImgDownload* downloader = [[ImgDownload alloc] init];
            
            downloader.urlString = f.thumb;
            downloader.delegate = self;
            [downloader image];
            
            [downloaders addObject:downloader];
            
        }
        
        [checker invalidate];
        checker = nil;
        ready = NO;
    }
}

-(void) clickFoto:(id) sender
{
    NSMutableArray* links = [NSMutableArray new];
    for (Foto * f in fotos) 
    {
        [links addObject:f.foto];
    }
    
    FotoZoom* zoom = [[FotoZoom alloc] init];
    
    zoom.urls = links;
    zoom.currentPage = [botoes indexOfObject:sender];
    
    [zoom setModalTransitionStyle:UIModalTransitionStyleCrossDissolve];
    
    [self presentModalViewController:zoom animated:YES];
}

-(void) startInterface
{
    @autoreleasepool 
    {
        
        
        fotos = [LogicCore getFotos:url];
        botoes = [NSMutableArray new];
        
        for (Foto * f in fotos) 
        {
            UIButton* button = [[UIButton alloc] initWithFrame:CGRectMake(0, 0, 163, 121)];

            //configuraçoes do botao
            [button addTarget:self action:@selector(clickFoto:) forControlEvents:UIControlEventTouchUpInside];
            
            [button setBackgroundColor:[UIColor orangeColor]];
            
            CGRect bFrame = button.frame;
            
            bFrame.origin.x = current.x+start.x;
            bFrame.origin.y = current.y+start.y;
            
            button.frame = bFrame;
            
            [botoes addObject:button];
            [scroll addSubview:button];
            
            
            if (current.x != 5*jump.width) 
            {
                current.x = current.x+jump.width;
            }
            else
            {
                current.x = 0;
                current.y = current.y+jump.height;
                
                if (f != [fotos lastObject]) 
                {
                    [scroll setContentSize:CGSizeMake(scroll.contentSize.width, scroll.contentSize.height+jump.height)];
                }   
            }
        }
        ready = YES;
    }  
}

#pragma mark - View lifecycle

- (void)viewDidLoad
{
    [super viewDidLoad];
    
    lock = [NSLock new];
    
    downloaders = [NSMutableArray new];
    
    start = CGPointMake(10, 0);
    current = CGPointMake(0, 0);

    jump = CGSizeMake(168, 126);

    [scroll setContentSize:CGSizeMake(1024, jump.height)];
    
    checker = [NSTimer scheduledTimerWithTimeInterval:(1.0/5.0) target:self selector:@selector(startDownloaders) userInfo:nil repeats:YES];
    
    [loading startAnimating];
    [NSThread detachNewThreadSelector:@selector(startInterface) toTarget:self withObject:nil];
    
    
    // Do any additional setup after loading the view from its nib.
}

- (void)viewDidUnload
{
    [self setScroll:nil];
    [self setLoading:nil];
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
	return ((interfaceOrientation == UIInterfaceOrientationLandscapeRight) || (interfaceOrientation == UIInterfaceOrientationLandscapeLeft));
}

- (IBAction)retornar:(id)sender {
    downloaders = nil;
    [self dismissModalViewControllerAnimated:YES];
}
@end
