//  Created by Sir Cheshire

#import "InitialView.h"
#import "LogicCore.h"
#import "Galeria.h"
#import "ImgDownload.h"
#import "FotosGaleria.h"

@implementation InitialView
@synthesize viewMsg;
@synthesize scroll;
@synthesize loading;
@synthesize txtView;
@synthesize mensagem;

-(void) showMsg
{
    if (viewMsg.frame.origin.y != msgStart.y) 
    {
        [UIView beginAnimations:@"showMsg" context:nil];
        CGRect tempF = viewMsg.frame;
        
        tempF.origin = msgStart;
        
        viewMsg.frame = tempF;
        

        [UIView commitAnimations];
    }
    
    [txtView setText:mensagem];
}

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)didReceiveMemoryWarning
{
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}

-(void) clickGaleria:(id)sender
{
    Galeria* g = [galerias objectAtIndex:[botoes indexOfObject:sender]];
    
    FotosGaleria* view = [[FotosGaleria alloc] init];
    
    view.url = g.url;
    
    [view setModalTransitionStyle:UIModalTransitionStyleFlipHorizontal];
    
    [self presentModalViewController:view animated:YES];
}

- (void)download:(ImgDownload *)download didFailWithError:(NSError *)error
{
    NSLog(@"erro no download da imagem de indice %d de endereço %@",[downloaders indexOfObject:download],download.urlString);
    
    dCount++;
    if (dCount == [downloaders count]) 
    {
        [loading stopAnimating];
        downloaders = nil;
    }
}

- (void)downloadDidFinishDownloading:(ImgDownload *)download
{

    [self finishButton:download];

    download.delegate = nil;
    NSLog(@"terminou download na imagem de indice %d de endereço %@",[downloaders indexOfObject:download], download.urlString);
    
    [lock lock];
    
    dCount++;
    if (dCount == [downloaders count]) 
    {
        [loading stopAnimating];
        downloaders = nil;
    }
    
    [lock unlock];
}

-(void) finishButton:(ImgDownload*) downloader
{
    UIImage* image = downloader.image;

    UIImageView* imagem = [[UIImageView alloc] initWithFrame:CGRectMake(7, 7, 306, 246)];

    [imagem setImage:image];

    UIButton* button = [botoes objectAtIndex:[downloaders indexOfObject:downloader]];

    [button addSubview:imagem];
}

- (NSInteger)numberOfComponentsInPickerView:(UIPickerView *)pickerView 
{
    return 1; 
}
- (NSInteger)pickerView:(UIPickerView *)pickerView numberOfRowsInComponent:(NSInteger)component 
{
    return 12;
}

-(UIView *)pickerView:(UIPickerView *)pickerView viewForRow:(NSInteger)row forComponent:(NSInteger)component reusingView:(UIView *)view 
{
    UILabel* lab; 
    if (view)
    {
        lab = (UILabel*)view; 
    }
    else
    {
        lab = [[UILabel alloc] init];
    }
    lab.text = [NSString stringWithFormat:@"%d",2000+row]; 
    lab.backgroundColor = [UIColor clearColor]; 
    [lab sizeToFit];
    return lab; 
}

- (IBAction)clickPesquisa:(id)sender 
{
    if ([popOver isPopoverVisible]) 
    {
        [popOver dismissPopoverAnimated:YES];
    } 
    else 
    {
        UIButton* t = (UIButton*) sender;
        [popOver presentPopoverFromRect:t.frame inView:self.view permittedArrowDirections:UIPopoverArrowDirectionUp animated:YES];
    }
}

- (IBAction)clickFB:(id)sender {
    [[UIApplication sharedApplication] openURL:[NSURL URLWithString:@"http://www.facebook.com/cariocaentre"]]; 
}

- (IBAction)clickTwt:(id)sender {
    [[UIApplication sharedApplication] openURL:[NSURL URLWithString:@"http://twitter.com/CariocaEntre"]]; 
}

- (IBAction)clickYT:(id)sender {
    [[UIApplication sharedApplication] openURL:[NSURL URLWithString:@"http://www.youtube.com/cariocaentre"]]; 
}

- (IBAction)clickLogo:(id)sender {
    [[scroll subviews] makeObjectsPerformSelector:@selector(removeFromSuperview)];
    
    current = CGPointMake(0, 0);
    [scroll setContentSize:CGSizeMake(1024, jump)];
    
    for (UIButton * b in botoes) 
    {
        CGRect frame = b.frame;
        
        frame.origin.x = current.x+start.x;
        frame.origin.y = current.y+start.y;
        
        b.frame = frame;
        
        [scroll addSubview:b];
        
        if (current.x != 2*jump) 
        {
            current.x = current.x+jump;
        }
        else
        {
            current.x = 0;
            current.y = current.y+jump;
            
            if (b != [botoes lastObject]) 
            {
                [scroll setContentSize:CGSizeMake(scroll.contentSize.width, scroll.contentSize.height+jump)];
            }   
        }
    }
}

-(void) startDownloaders
{
    if (ready) 
    {
        for (Galeria * g in galerias) 
        {
            //foto
            ImgDownload* downloader = [[ImgDownload alloc] init];
            
            downloader.urlString = g.foto;
            downloader.delegate = self;
            [downloader image];
            
            [downloaders addObject:downloader];
            
        }
        
        [checker invalidate];
        checker = nil;
        ready = NO;
    }
}

#pragma mark - View lifecycle

-(void) actionSheet:(UIActionSheet *)actionSheet clickedButtonAtIndex:(NSInteger)buttonIndex
{
    [loading startAnimating];
    [NSThread detachNewThreadSelector:@selector(startInterface) toTarget:self withObject:nil];
}

-(void) startInterface
{
    @autoreleasepool 
    {
        galerias = [LogicCore getGalerias];
        botoes = [NSMutableArray new];
        
        if ([galerias count] == 0) 
        {
            [loading stopAnimating];
            
            UIActionSheet* sheet = [[ UIActionSheet alloc] initWithTitle:@"Falha na conexão." delegate:self cancelButtonTitle:nil destructiveButtonTitle:nil otherButtonTitles:@"Tentar novamente",nil];
            
            [sheet showInView:scroll];
        }
        else
        {
            for (Galeria * g in galerias) 
            {
                UIButton* button = [[UIButton alloc] initWithFrame:CGRectMake(0, 0, 320, 320)];
                
                //nome
                UILabel* nome = [[UILabel alloc] initWithFrame:CGRectMake(25, 271, 288, 19)];
                
                [nome setText: [NSString stringWithFormat:@"%@",g.nome]];
                
                [nome setTextColor:[UIColor whiteColor]];
                
                [nome setBackgroundColor:[UIColor clearColor]];
                
                [nome setFont:[UIFont fontWithName:@"Futura" size:18]];
                
                [nome setMinimumFontSize:18];
                
                [button addSubview:nome];
                
                //dados
                UILabel* dados = [[UILabel alloc] initWithFrame:CGRectMake(25, 289, 288,21)];
                
                [dados setText:[NSString stringWithFormat:@"%@ :: %@",g.data,g.local]];
                
                [dados setTextColor:[UIColor blackColor]];
                [dados setBackgroundColor:[UIColor clearColor]];
                
                [dados setFont:[UIFont fontWithName:@"Futura" size:13]];
                
                [dados setMinimumFontSize:14];
                
                [button addSubview:dados];
                
                //configuraçoes do botao
                [button addTarget:self action:@selector(clickGaleria:) forControlEvents:UIControlEventTouchUpInside];
                
                [button setBackgroundColor:[UIColor orangeColor]];
                
                CGRect bFrame = button.frame;
                
                bFrame.origin.x = current.x+start.x;
                bFrame.origin.y = current.y+start.y;
                
                button.frame = bFrame;
                
                [botoes addObject:button];
                [scroll addSubview:button];
                
                
                if (current.x != 2*jump) 
                {
                    current.x = current.x+jump;
                }
                else
                {
                    current.x = 0;
                    current.y = current.y+jump;
                    
                    if (g != [galerias lastObject]) 
                    {
                        [scroll setContentSize:CGSizeMake(scroll.contentSize.width, scroll.contentSize.height+jump)];
                    }   
                }
            }
            ready = YES;
        } 
    }  
}

-(void) okPesquisa:(id)sender
{
    [[scroll subviews] makeObjectsPerformSelector: @selector(removeFromSuperview)];
    
    NSString* nome = campoPesquisa.text;
    
    NSString* ano = [NSString stringWithFormat:@"%d",[picker selectedRowInComponent:0]+2000];
    
    current = CGPointMake(0, 0);
    [scroll setContentSize:CGSizeMake(1024, jump)];
        
    for (Galeria * g in galerias) 
    {
        if (campoPesquisa.text && ![campoPesquisa.text isEqualToString:@""] && ![campoPesquisa.text isEqualToString:@" "]) 
        {
            NSRange textRange;
            textRange =[[g.nome lowercaseString] rangeOfString:[nome lowercaseString]];
            
            if(textRange.location != NSNotFound)
            {
                NSRange textRange2;
                textRange2 =[g.data  rangeOfString:ano];
                
                if(textRange2.location != NSNotFound)
                {
                    UIButton* temp = [botoes objectAtIndex:[galerias indexOfObject:g]];
                    
                    CGRect frame = temp.frame;
                    
                    frame.origin.x = current.x+start.x;
                    frame.origin.y = current.y+start.y;
                    
                    temp.frame = frame;
                    
                    [scroll addSubview:temp];
                    
                    if (current.x != 2*jump) 
                    {
                        current.x = current.x+jump;
                    }
                    else
                    {
                        current.x = 0;
                        current.y = current.y+jump;
                        
                        if (g != [galerias lastObject]) 
                        {
                            [scroll setContentSize:CGSizeMake(scroll.contentSize.width, scroll.contentSize.height+jump)];
                        }   
                    }
                }
            }  
        }
        else
        {
            NSRange textRange2;
            textRange2 =[g.data rangeOfString:ano];
            
            if(textRange2.location != NSNotFound)
            {
                NSRange textRange2;
                textRange2 =[g.data  rangeOfString:ano];
                
                if(textRange2.location != NSNotFound)
                { 
                    UIButton* temp = [botoes objectAtIndex:[galerias indexOfObject:g]];
                    
                    CGRect frame = temp.frame;
                    
                    frame.origin.x = current.x+start.x;
                    frame.origin.y = current.y+start.y;
                    
                    temp.frame = frame;
                    
                    [scroll addSubview:temp];
                    
                    if (current.x != 2*jump) 
                    {
                        current.x = current.x+jump;
                    }
                    else
                    {
                        current.x = 0;
                        current.y = current.y+jump;
                        
                        if (g != [galerias lastObject]) 
                        {
                            [scroll setContentSize:CGSizeMake(scroll.contentSize.width, scroll.contentSize.height+jump)];
                        }   
                    }
                }  
            }  
        }
    }

    [popOver dismissPopoverAnimated:YES];
}

-(void) awakeFromNib
{
    [super awakeFromNib];
}

- (void)viewDidLoad
{
    [super viewDidLoad];
    
    lock = [NSLock new];
    
    UIView* telaPesquisa = [[UIView alloc] initWithFrame:CGRectMake(0,0, 579, 303)];
    
    [telaPesquisa setBackgroundColor:[UIColor whiteColor]];
    
    picker = [[UIPickerView alloc] initWithFrame:CGRectMake(15, 44, 282, 216)];
    
    campoPesquisa = [[UITextField alloc] initWithFrame:CGRectMake(312, 125, 250,30)];
    
    [campoPesquisa setFont:[UIFont fontWithName:@"Futura" size:26]];
    
    [campoPesquisa setBackgroundColor:[UIColor grayColor]];
    
    UIButton* okPesquisa =[[UIButton alloc] initWithFrame:CGRectMake(312, 165, 100, 50)];
    
    [okPesquisa setBackgroundImage:[UIImage imageNamed:@"Button@Ok.png"] forState:UIControlStateNormal];
    [okPesquisa setBackgroundImage:[UIImage imageNamed:@"Button@OkOver.png"] forState:UIControlStateHighlighted];
    
    [okPesquisa addTarget:self action:@selector(okPesquisa:) forControlEvents:UIControlEventTouchUpInside];
    
    [picker setDelegate:self];
    [picker setDataSource:self];
    [picker setShowsSelectionIndicator:YES];
    
    [telaPesquisa addSubview:campoPesquisa];
    [telaPesquisa addSubview:picker];
    [telaPesquisa addSubview:okPesquisa];
    
    UIViewController* temp = [[UIViewController alloc] init];
    
    [temp.view addSubview:telaPesquisa];
    
    popOver = [[UIPopoverController alloc] initWithContentViewController:temp];
    
    [popOver setPopoverContentSize:telaPesquisa.frame.size];
    
    downloaders = [NSMutableArray new];
    
    start = CGPointMake(22, 0);
    current = CGPointMake(0, 0);
    
    jump = 330;
    
    [scroll setContentSize:CGSizeMake(1024, jump)];
    
    checker = [NSTimer scheduledTimerWithTimeInterval:(1.0/5.0) target:self selector:@selector(startDownloaders) userInfo:nil repeats:YES];
    
    [loading startAnimating];
    
    msgStart= viewMsg.frame.origin;
    
   /* CGRect tempF = viewMsg.frame;
    
    tempF.origin = msgStart;
    
    viewMsg.frame = tempF;*/
    
    viewMsg.frame = CGRectOffset(viewMsg.frame, 0,748-viewMsg.frame.origin.y);
    
    [NSThread detachNewThreadSelector:@selector(startInterface) toTarget:self withObject:nil];
    // Do any additional setup after loading the view from its nib.
}

- (void)viewDidUnload
{
    [self setScroll:nil];
    [self setLoading:nil];
    [self setViewMsg:nil];
    [self setTxtView:nil];
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
	return ((interfaceOrientation == UIInterfaceOrientationLandscapeLeft)|| (interfaceOrientation == UIInterfaceOrientationLandscapeRight));
}

- (IBAction)fecharMsg:(id)sender {
    
    [UIView beginAnimations:@"fecharMsg" context:nil];
    
    viewMsg.frame = CGRectOffset(viewMsg.frame, 0,748-viewMsg.frame.origin.y);
    
    [UIView commitAnimations];
}
@end
