//  Created by Sir Cheshire

#import "FotoZoom.h"

@implementation FotoZoom
@synthesize barra;
@synthesize scroll,urls,currentPage;


-(void) addFoto:(ImgDownload *)downloader
{
    //adicionar a foto de fato na scrollview, parar o loading
    
    UIImageView* image = [[UIImageView alloc] initWithImage:downloader.image];
    
    UIActivityIndicatorView* loading = [loaders objectAtIndex:[downloaders indexOfObject:downloader]];
    
    [loading stopAnimating];

    int index = [downloaders indexOfObject:downloader];
    
    float imgRatio = downloader.image.size.width/downloader.image.size.height;
    float scrRatio = 1024.0/748.0;
    
    if (imgRatio > scrRatio) 
    {
        float height = 1024/imgRatio;
        image.frame=CGRectMake((1024*index), (748-height)/2, 1024, height);
    }
    else
    {
        float width = 748*imgRatio;
        image.frame = CGRectMake((1024*index)+((1024-width)/2), 0, width, 748);        
    }
    
    
    
    [scroll addSubview:image];
    
    
    if (index > 0) 
    {
        [self notifyPage:index -1];
    }
        
    if (index < [downloaders count]-1) 
    {
        [self notifyPage:index+1];
    }
}

- (void)download:(ImgDownload *)download didFailWithError:(NSError *)error
{
    NSLog(@"erro no download da imagem de indice %d de endereço %@",[downloaders indexOfObject:download],download.urlString);
    
    count = count++;
    
    [[loaders objectAtIndex:[downloaders indexOfObject:download]] removeFromSuperview];
    if (count == [urls count]) 
    {
        loaders = nil;
        downloaders = nil;
        urls = nil;
    }
}

- (void)downloadDidFinishDownloading:(ImgDownload *)download
{
    
    [self addFoto:download];

    download.delegate = nil;
    
    [lock lock];
    count = count++;
    
     [[loaders objectAtIndex:[downloaders indexOfObject:download]] removeFromSuperview];
    if (count == [urls count]) 
    {
       
        loaders = nil;
        downloaders = nil;
        urls = nil;
    }
    
    [lock unlock];
    NSLog(@"terminou download na imagem de indice %d de endereço %@",[downloaders indexOfObject:download], download.urlString);
    
}

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)didReceiveMemoryWarning
{
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}

#pragma mark - View lifecycle

-(void) notifyPage:(int) page
{
    ImgDownload* temp = [downloaders objectAtIndex:page];
    
    [temp image];
}

- (IBAction)return:(id)sender
{
    downloaders = nil;
    
    [self dismissModalViewControllerAnimated:YES];
}

-(void) scrollViewDidEndDecelerating:(UIScrollView *)scrollView
{
    CGFloat pageWidth = scroll.frame.size.width;
    int page = floor((scroll.contentOffset.x - pageWidth / 2) / pageWidth) + 1;
    
    if (page != currentPage)
    {
        currentPage = page;
        [self notifyPage:currentPage];
    }
}

-(void) toggleBar
{
    [UIView beginAnimations:@"barra" context:nil];
    if (barra.alpha == 0.0) 
    {
        barra.alpha = 1.0;
    }
    else
    {
        barra.alpha = 0.0;
    }
    [UIView commitAnimations];
}


- (void)viewDidLoad
{
    [super viewDidLoad];
    
    lock = [NSLock new];
    
    downloaders = [NSMutableArray new];
    loaders = [NSMutableArray new];
        
    for (NSString * l in urls) 
    {
        //foto
        ImgDownload* downloader = [[ImgDownload alloc] init];
        
        downloader.urlString = l;
        downloader.delegate = self;
        
        [downloaders addObject:downloader];
        
        UIActivityIndicatorView* loading = [[UIActivityIndicatorView alloc] initWithFrame:CGRectMake(([urls indexOfObject:l]*1024)+494, 355, 37, 37)];
        
        [loading setActivityIndicatorViewStyle:UIActivityIndicatorViewStyleWhiteLarge];
        
        [loading setHidesWhenStopped:YES];
        [loading startAnimating];
        
        [loaders addObject:loading];
        [scroll addSubview:loading];   
    }
    
    [scroll setContentSize:CGSizeMake([urls count]*1024, scroll.frame.size.height)];

    [self notifyPage:currentPage];
    [scroll scrollRectToVisible:CGRectMake(currentPage*1024, 0, 1024, scroll.frame.size.height) animated:YES];
    
    UITapGestureRecognizer* tap = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(toggleBar)];
    
    [scroll addGestureRecognizer:tap];
    // Do any additional setup after loading the view from its nib.
}

- (void)viewDidUnload
{
    [self setScroll:nil];
    [self setBarra:nil];
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
	return ((interfaceOrientation == UIInterfaceOrientationLandscapeLeft) || (interfaceOrientation == UIInterfaceOrientationLandscapeRight));
}

@end
